/************************************************************************/
/*																		*/
/*	R2R.h	--	Declaration for R2R library 	    					*/
/*																		*/
/************************************************************************/
/*	Author:		Eric Marsh												*/
/*	Copyright 2016, Digilent Inc.										*/
/************************************************************************/
/*  File Description:													*/
/*	This file declares the PmodR2R library functions and the constants	*/
/*	involved.															*/
/*																		*/
/************************************************************************/
/*  Revision History:													*/
/*																		*/
/*	06/30/2016(EricM): created											*/
/*																		*/
/************************************************************************/
#if !defined(R2R_H)
#define R2R_H


/* ------------------------------------------------------------ */
/*				Include File Definitions						*/
/* ------------------------------------------------------------ */
#include <inttypes.h>
#include <DSPI.h>

/* ------------------------------------------------------------ */
/*					Definitions									*/
/* ------------------------------------------------------------ */
#define R2R_SPI_FREQ	1000000 // 1 MHz - default spi freq
#define	PAR_ACCESS_SPI0			0
#define	PAR_ACCESS_SPI1			1

/* ------------------------------------------------------------ */
/*					Procedure Declarations						*/
/* ------------------------------------------------------------ */


class R2R {
private: 
	DSPI *pdspi;
	uint8_t m_SSPin;
	int pinTable[8];
	int binArray[8];
	
public:
	R2R();
	void begin(uint8_t bAccessType, uint32_t spd = R2R_SPI_FREQ, uint8_t SSpin = -1);	
	void ConvertIntegerToBinaryArray(int num);
	void SendBinaryArray(int *binArray);
	void SendInteger(int num);
	void PrintBinaryArray();
};

#endif
